import {Component, OnInit, ViewChild} from '@angular/core';
import {ScheduleInfo, ScheduleService} from "../../api";
import {ActiveScheduleComponent} from "./active-schedule/active-schedule.component";

@Component({
  selector: 'app-dashboard',
  templateUrl: './dashboard.component.html',
  styleUrls: ['./dashboard.component.css']
})
export class DashboardComponent implements OnInit{

  missedSchedules: boolean = true
  schedules: ScheduleInfo[] = []

  @ViewChild('activeSchedule') activeScheduleComponent: ActiveScheduleComponent | undefined
  constructor(private scheduleService: ScheduleService) {
  }

  ngOnInit() {
    this.scheduleService.schedulesTodayGet().subscribe({
      next: resp => {
        this.schedules = resp;
      }
    })


  }

  startSchedule(schedule: ScheduleInfo) {
    this.scheduleService.schedulesScheduleIDActivatePost(schedule.scheduleID).subscribe({
      next: resp => {
        schedule.startTime = resp.startTime;
        if(this.activeScheduleComponent != undefined) {
          this.activeScheduleComponent.activeSchedule = schedule;
        }
      }
    })
  }


}
